_G.AntiMethHelper = _G.AntiMethHelper or {}

function AntiMethHelper:is_spam(msg)
	msg = utf8.to_lower(msg:gsub("%b[][^%s]*%s*", ""))
	
	for mod, data in pairs(AntiMethHelper.spam) do
		for k, mod_data in pairs(data) do
			if AntiMethHelper._data.langs[k] then
				for _, spam in ipairs(mod_data) do
					if msg == utf8.to_lower(spam) then
						return true
					end
				end
			end
		end
		
		for _, rx in ipairs(data.regexes or {}) do
			if msg:match(utf8.to_lower(rx)) then
				return true
			end
		end
	end
end

local ChatManager_receive_message_by_peer = ChatManager.receive_message_by_peer

function ChatManager:receive_message_by_peer(channel_id, peer, message)
	if peer:id() ~= managers.network:session():local_peer():id() and AntiMethHelper:is_spam(message) then
		return
	end
	
	ChatManager_receive_message_by_peer(self, channel_id, peer, message)
end